//  BMPx - The Dumb Music Player
//  Copyright (C) 2005 BMPx development team.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_LIBRARY_UI_MODIFY_TRACKS_HPP 
#define BMP_LIBRARY_UI_MODIFY_TRACKS_HPP

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glibmm.h>
#include <glibmm/markup.h>
#include <gtkmm.h>
#include <libglademm.h>

#include "amazon.hpp"
#include "library.hpp"
#include "musicbrainz_xml.hpp"

namespace Bmp
{
  class LibraryUIModifyTracks
    : public Gtk::Dialog
  {
    public:

	LibraryUIModifyTracks (BaseObjectType                       *cobject,
			       const Glib::RefPtr<Gnome::Glade::Xml> &xml);

	static LibraryUIModifyTracks*
	create ();

	int
	run (const Glib::ustring& releaseid, 
	     const Glib::ustring& artist,
	     const Glib::ustring& album); //FIXME: Theoretically we should allow this only for albums for which mb release exists in the db

	Bmp::Library::UpdateTracks u_tracks;

    private:

      class ColumnRecordTrack
	  : public Gtk::TreeModel::ColumnRecord
      {
	public:

	  Gtk::TreeModelColumn<unsigned int>  nr;
	  Gtk::TreeModelColumn<Glib::ustring> title;
	  Gtk::TreeModelColumn<Glib::ustring> track_id; 
	  Gtk::TreeModelColumn<Glib::ustring> artist_id;

	  ColumnRecordTrack ()
	  {
	    add (nr);
	    add (title);
	    add (track_id);
	    add (artist_id);
	  }
      };
      ColumnRecordTrack crtracks;

      class ColumnRecordUpdateTrack
	  : public Gtk::TreeModel::ColumnRecord
      {
	public:

	  Gtk::TreeModelColumn<bool>	      mod;
	  Gtk::TreeModelColumn<unsigned int>  nr;
	  Gtk::TreeModelColumn<Glib::ustring> title;
	  Gtk::TreeModelColumn<Glib::ustring> location;

	  ColumnRecordUpdateTrack ()
	  {
	    add (mod);
	    add (nr);
	    add (title);
	    add (location);
	  }
      };
      ColumnRecordUpdateTrack crupdatetracks;

      // GladeXML+Widgets
      Glib::RefPtr<Gnome::Glade::Xml> ref_xml;

      Gtk::TreeView		    *view_release;
      Gtk::TreeView		    *view_local;
      Gtk::Button		    *b_move_up;
      Gtk::Button		    *b_move_down;

      Gtk::Label		    *l_artist;
      Gtk::Label		    *l_album;

      Gtk::Image		    *i_coverart;
      Glib::RefPtr<Gdk::Pixbuf>	     disc;

      Glib::RefPtr<Gtk::ListStore>   store_release;
      Glib::RefPtr<Gtk::ListStore>   store_local;

      // Internals
      void
      local_selection_changed ();
      void
      on_button_down ();
      void
      on_button_up   ();
      void
      cell_data_func_nr (Gtk::CellRenderer* cell, const Gtk::TreeModel::iterator& iter);
      void
      on_mod_toggled (const Glib::ustring& path);
  };
}
#endif
