// (c) 2005 Martin Aumueller <aumuell@reserv.at>
// See COPYING file for licensing information

#include "taglib_mp4filetyperesolver.h"
#include "mp4file.h"

#include <src/util.hpp> 

namespace 
{
  char* const suffixes[] =
  {
    "m4a",
    "m4b",
    "m4p",
    "mp4",
    "m4v",
    "mp4v",
    0,
  };
}

TagLib::File *MP4FileTypeResolver::createFile(const char *filename,
        bool readProperties,
        TagLib::AudioProperties::ReadStyle propertiesStyle) const
{
    if (str_has_suffixes_nocase (filename, suffixes))
    {
        MP4FileHandle h = MP4Read(filename, 0);
        if(MP4_INVALID_FILE_HANDLE == h)
        {
            return 0;
        }

        return new TagLib::MP4::File(filename, readProperties, propertiesStyle, h);
    }

    return 0;
}
