// (c) 2005 Martin Aumueller <aumuell@reserv.at>
// See COPYING file for licensing information

#include "taglib_wmafiletyperesolver.h"
#include "wmafile.h"

#include <src/util.hpp>

namespace
{
  char* const suffixes[] = 
  {
    "wma",
    "asf",
    0,
  };
}

TagLib::File *WMAFileTypeResolver::createFile (const char                        *filename,
                                               bool                               readProperties,
                                               TagLib::AudioProperties::ReadStyle propertiesStyle) const 
{
    if (str_has_suffixes_nocase (filename, suffixes))
    {
        TagLib::WMA::File *f = new TagLib::WMA::File(filename, readProperties, propertiesStyle);
        if(f->isValid())
            return f;
        else
        {
            delete f;
        }
    }

    return 0;
}
